



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Mybatis框架学习总结-调用存储过程</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Mybatis框架学习总结-调用存储过程</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 21:13:54 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h4>设计需求</h4>
<p>查询数据库，查询得到男性或女性的数量，如果传入的参数是0查询女性，否则查询男性。</p>
<h4>准备数据库表和存储过程</h4>
<p>1.准备person表：</p>
<div>
<pre class="prettyprint linenums">CREATE TABLE person(<br />
 id INT PRIMARY KEY AUTO_INCREMENT,<br />
 NAME VARCHAR(10),<br />
 sex CHAR(2)<br />
);

INSERT INTO person(NAME,sex) VALUES('A',"m");<br />
INSERT INTO person(NAME,sex) VALUES('B',"f");<br />
INSERT INTO person(NAME,sex) VALUES('C',"m");</pre>
</div>
<p>查看person表的内容：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1177029/201711/1177029-20171116131447234-101043032.png" /></p>
<p>创建存储过程：</p>
<p>创建存储过程，查询得到男性或女性的数量，如果传入的是0就是女性，否则就是男性</p>
<div>
<pre class="prettyprint linenums">DELIMITER $<br />
 CREATE PROCEDURE mybatis.ges_person_count(IN sex_id INT ,OUT person_count INT)<br />
 BEGIN<br />
 IF sex_id=0 THEN<br />
 SELECT COUNT(*) FROM mybatis.`person` WHERE person.`sex`='f' INTO person_count;<br />
 ELSE<br />
 SELECT COUNT(*) FROM mybatis.`person` WHERE person.`sex`='m' INTO person_count;<br />
 END IF;<br />
 END<br />
$</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1177029/201711/1177029-20171116132017077-800882956.png" /></p>
<p>调用存储过程</p>
<div>
<pre class="prettyprint linenums">DELIMITER ;<br />
SET @person_count=0;<br />
CALL mybatis.`ges_person_count`(1,@person_count);<br />
SELECT @person_count;</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1177029/201711/1177029-20171116132149156-1778527930.png" /></p>
<p>2.编辑userMapper.xml，你也可以在别的xml中配置，这个随意</p>
<div>
<pre class="prettyprint linenums">&lt;!-- 调用存储过程得到男性或女性的数量，如果传入的是0，就女性，否则是男性 --&gt;<br />
    &lt;select id="getPersonCount" parameterMap="getPersonCountMap" statementType="CALLABLE"&gt;<br />
        CALL mybatis.`ges_person_count`(?,?);<br />
    &lt;/select&gt;

    &lt;!-- parameterMap.put("sexid",0)<br />
         parameterMap.put("usercount,-1);<br />
     --&gt;<br />
     &lt;parameterMap type="java.util.Map" id="getPersonCountMap"&gt;<br />
         &lt;parameter property="sexid" mode="IN" jdbcType="INTEGER"/&gt;<br />
         &lt;parameter property="personcount" mode="OUT" jdbcType="INTEGER"/&gt;<br />
     &lt;/parameterMap&gt;</pre>
</div>
<p>3.编写单元测试代码：</p>
<div>
<pre class="prettyprint linenums">Reader reader = Resources.getResourceAsReader(resource);<br />
        SqlSessionFactory sessionFactory = new SqlSessionFactoryBuilder().build(reader);<br />
        String statement = "com.fpc.Mapping.userMapper.getPersonCount";<br />
        SqlSession session = sessionFactory.openSession();<br />
        Map&lt;String,Integer&gt; parameterMap = new HashMap&lt;&gt;();<br />
        parameterMap.put("sexid", 0);<br />
        parameterMap.put("personcount", -1);<br />
        session.selectOne(statement,parameterMap);<br />
        int count = parameterMap.get("personcount");<br />
        String profile = "";<br />
        if ( parameterMap.get("sexid") == 0 ) {<br />
            profile += "女生的数量为:";<br />
        } else {<br />
            profile += "男生的树数量为:";<br />
        }<br />
        System.out.println( profile + count);</pre>
</div>
<p>执行结果：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1177029/201711/1177029-20171116133620812-1277077546.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8m26prq.html">C&num; 将PDF文件转换为word格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8em06e9.html">ObjectAnimator属性动画应用demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/r937non8.html">windows下git识别大小写配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwgvrk8.html">EXT学习之&mdash;&mdash;EXT下拉框默认绑定第一个值</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlr1zxq.html">创建一个swift项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn3wnk9.html">【转】php json&lowbar;encode中文为空的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1yk1z9.html">js   confirm用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xjx3z9.html">bzoj 2141 线段树套平衡树</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m7wgeq.html">Java：Object类</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z60w09.html">JS屏蔽右键菜单，复制，粘帖xxxxx&period;&period;&period;&period;&period;&period;&period;&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdey02j9.html">表单数据校检方法 onsubmit&lpar;&rpar;的使用？</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vo30m8.html">vb&period;net常用函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x621m8.html">leetcode first bad version python</a>
		</li>
						<li><a href="https://www.batexi.com/a/9geggwl8.html">Java之异常处理，日期处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj3x4xq.html">悟透JavaScript&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd2nr49.html">C&num; 多线程、异步线程、线程池相关知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgw3ym8.html">HTML5学习知识点</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pe7g48.html">Raneto部署知识库平台&amp;amp&semi;支持中文搜索</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2505kxq.html">mysql5&period;6基于主从复制的mmm高可用架构详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gylmvq.html">Oracle ORDS的简单SQL配置模板</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnnryngq.html">oozie开发注意事项</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7epd6j9.html">javascript 屏蔽F5，BackSpace等各种按键</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pe7k5q.html">jQuery替换内容</a>
			</li>
						<li><a href="https://www.batexi.com/a/9535zlz8.html">imx6 uboot splash image</a>
			</li>
						<li><a href="https://www.batexi.com/a/qveg32j9.html">Unity获取文件夹下指定类型的文件数量</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1zp269.html">【BZOJ】1669&colon; &lbrack;Usaco2006 Oct&rsqb;Hungry Cows饥饿的奶牛（lis）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyve0k2q.html">3&percnt; of users browse with IE9 and 14&percnt; of users have a disability&period; Why do we only cater for the former&quest;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2k76loq.html">sdut 2153&colon;Clockwise（第一届山东省省赛原题，计算几何&plus;DP）</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1zdj19.html">ionic listview对象的编辑、排序和删除</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjo4vr8.html">rimraf删除gulp的模块插件</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
